*- Name.....DBF Definition (dbfDef)
*- Author...Todd Kreuter
*- For......dB2K

*- Usage
	// do dbfDef <TableName>
	// TableName: Optional character expression containing
   // the name of the table, i.e. "Customer" or "Customer.dbf"

*- Description
	// For viewing and reporting table information and
   // generating create table command

*- Special Notes
	// Only for dBASE tables (dbf)
   // Any custom classes used are included herein
   // see additional header notes in those classes

   // Create table generator is limited to 1096 characters
   // and will not add a primary key.  Plan to increase 
   // limitation (using alter table) and adding primary key
   // in the future.


*- History
// 2001.0626 - Original
// 2001.0706 - Reduced field name lengths, correct error when
//					BDE table level was < 7
// 2001.0715 - Added ability to pass table name with do dbfDef
*- End Header

#Define GotColor "WindowText" + "/" + "Cyan"
#Define LostColor "WindowText" + "/" + "Window"
#Define NormalColor "BtnText/BtnFace"

parameter cTableName
local f
f = new DBFDefForm()

// If tableName passed as parameter,
// save as property of form for processing
if TYPE("cTableName") == "C"
	f.openTable = cTableName
endif
f.open()


return

class DBFDefForm of FORM
   with (this)
      onClose = {||this.release()}
      metric = 6	// Pixels
      height = 250
      width = 386
      text = "DBF Definition Utility"
      autoCenter = true
   endwith

   this.DATABASE = new DATABASE()
   this.DATABASE.parent = this
   with (this.DATABASE)
      left = 0
      top = 0
   endwith

   this.QFIELD = new TMPQUERY()
   this.QFIELD.parent = this
   with (this.QFIELD)
      canOpen = class::QFIELD_CANOPEN
      sql = "Select * from '_TMP8832'"
      active = true
   endwith

   this.QINDEX = new TMPQUERY()
   this.QINDEX.parent = this
   with (this.QINDEX)
      canOpen = class::QINDEX_CANOPEN
      sql = "Select * from '_TMP7990'"
      active = true
   endwith

   this.QREPORT = new TMPQUERY()
   this.QREPORT.parent = this
   with (this.QREPORT)
      canOpen = class::QREPORT_CANOPEN
      sql = "Select * from 'QTMP1607'"
   endwith

   this.GTE = new TEXT(this)
   with (this.GTE)
      height = 22
      width = 300
      fontName = "Arial"
      fontSize = 10
      text = ""
   endwith

   this.NB = new NOTEBOOK(this)
   with (this.NB)
      height = 250
      left = 0
      top = 0
      width = 386
      fontSize = 8
      dataSource = 'ARRAY {"Table","Field","Index","Create Table"}'
   endwith

   this.NB.GETTABLE1 = new GETTABLE(this.NB)
   with (this.NB.GETTABLE1)
      left = 6
      top = 30
      width = 374
      height = 88
   endwith

   this.NB.LABEL1 = new LABELBC(this.NB)
   with (this.NB.LABEL1)
      left = 10
      top = 126
      width = 70
      text = "Type/Version:"
   endwith

   this.NB.LABEL2 = new LABELBC(this.NB)
   with (this.NB.LABEL2)
      left = 10
      top = 150
      width = 70
      text = "Language:"
   endwith

   this.NB.LABEL3 = new LABELBC(this.NB)
   with (this.NB.LABEL3)
      left = 10
      top = 174
      width = 70
      text = "Primary Key:"
   endwith

   this.NB.LABEL4 = new LABELBC(this.NB)
   with (this.NB.LABEL4)
      left = 10
      top = 198
      width = 60
      text = "Records:"
   endwith

   this.NB.DLABEL1 = new LABELCB(this.NB)
   with (this.NB.DLABEL1)
      left = 82
      top = 124
      width = 130
   endwith

   this.NB.DLABEL2 = new LABELCB(this.NB)
   with (this.NB.DLABEL2)
      left = 82
      top = 148
      width = 130
   endwith

   this.NB.DLABEL3 = new LABELCB(this.NB)
   with (this.NB.DLABEL3)
      left = 82
      top = 172
      width = 130
   endwith

   this.NB.DLABEL4 = new LABELCB(this.NB)
   with (this.NB.DLABEL4)
      left = 82
      top = 196
      width = 130
   endwith

   this.NB.CBCONVERT = new CHECKBOX(this.NB)
   with (this.NB.CBCONVERT)
      when = {||False}
      height = 16
      left = 82
      top = 222
      width = 80
      text = "Converted"
      fontSize = 8
   endwith

   this.NB.PBVIEW = new PUSHBUTTON(this.NB)
   with (this.NB.PBVIEW)
      onClick = class::REPORT_ONCLICK
      height = 26
      left = 288
      top = 124
      width = 90
      text = "Pre&view"
      fontSize = 8
   endwith

   this.NB.PBPRINT = new PUSHBUTTON(this.NB)
   with (this.NB.PBPRINT)
      onClick = class::REPORT_ONCLICK
      height = 26
      left = 288
      top = 156
      width = 90
      text = "&Print"
      fontSize = 8
   endwith

   this.NB.DLABEL5 = new LABELBC(this.NB)
   with (this.NB.DLABEL5)
      left = 210
      top = 4
      width = 160
      text = ""
      colorNormal = "HighLight/BtnFace"
      pageno = 0
   endwith

   this.NB.GFIELD = new GRID(this.NB)
   with (this.NB.GFIELD)
      dataLink = form.qfield.rowset
      columns["COLUMN1"] = new GRIDCOLUMN(form.NB.GFIELD)
      columns["COLUMN1"].dataLink = form.qfield.rowset.fields["name"]
      columns["COLUMN1"].editorType = 1	// EntryField
      columns["COLUMN1"].width = 100
      columns["COLUMN2"] = new GRIDCOLUMN(form.NB.GFIELD)
      columns["COLUMN2"].dataLink = form.qfield.rowset.fields["type"]
      columns["COLUMN2"].editorType = 1	// EntryField
      columns["COLUMN2"].width = 83
      columns["COLUMN3"] = new GRIDCOLUMN(form.NB.GFIELD)
      columns["COLUMN3"].dataLink = form.qfield.rowset.fields["length"]
      columns["COLUMN3"].editorType = 1	// EntryField
      columns["COLUMN3"].width = 30
      columns["COLUMN4"] = new GRIDCOLUMN(form.NB.GFIELD)
      columns["COLUMN4"].dataLink = form.qfield.rowset.fields["decimal"]
      columns["COLUMN4"].editorType = 1	// EntryField
      columns["COLUMN4"].width = 30
      columns["COLUMN5"] = new GRIDCOLUMN(form.NB.GFIELD)
      columns["COLUMN5"].dataLink = form.qfield.rowset.fields["sqltype"]
      columns["COLUMN5"].editorType = 1	// EntryField
      columns["COLUMN5"].width = 86
      with (columns["COLUMN1"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN1"].headingControl)
         fontSize = 8
         value = "Name"
      endwith

      with (columns["COLUMN2"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN2"].headingControl)
         fontSize = 8
         value = "Type"
      endwith

      with (columns["COLUMN3"].editorControl)
         picture = "999"
         fontSize = 8
      endwith

      with (columns["COLUMN3"].headingControl)
         fontSize = 8
         value = " Len"
      endwith

      with (columns["COLUMN4"].editorControl)
         picture = "99"
         fontSize = 8
      endwith

      with (columns["COLUMN4"].headingControl)
         fontSize = 8
         value = " Dec"
      endwith

      with (columns["COLUMN5"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN5"].headingControl)
         fontSize = 8
         value = "SQL Type"
      endwith

      bgColor = "white"
      cellHeight = 18
      allowEditing = false
      allowAddRows = false
      pageno = 2
      height = 213
      left = 6
      top = 30
      width = 374
   endwith

   this.NB.GINDEX = new GRID(this.NB)
   with (this.NB.GINDEX)
      dataLink = form.qindex.rowset
      columns["COLUMN1"] = new GRIDCOLUMN(form.NB.GINDEX)
      columns["COLUMN1"].dataLink = form.qindex.rowset.fields["name"]
      columns["COLUMN1"].editorType = 1	// EntryField
      columns["COLUMN1"].width = 100
      columns["COLUMN2"] = new GRIDCOLUMN(form.NB.GINDEX)
      columns["COLUMN2"].dataLink = form.qindex.rowset.fields["express"]
      columns["COLUMN2"].editorType = 1	// EntryField
      columns["COLUMN2"].width = 100
      columns["COLUMN3"] = new GRIDCOLUMN(form.NB.GINDEX)
      columns["COLUMN3"].dataLink = form.qindex.rowset.fields["forexpress"]
      columns["COLUMN3"].editorType = 1	// EntryField
      columns["COLUMN3"].width = 99
      columns["COLUMN4"] = new GRIDCOLUMN(form.NB.GINDEX)
      columns["COLUMN4"].dataLink = form.qindex.rowset.fields["descend"]
      columns["COLUMN4"].editorType = 2	// CheckBox
      columns["COLUMN4"].width = 15
      columns["COLUMN5"] = new GRIDCOLUMN(form.NB.GINDEX)
      columns["COLUMN5"].dataLink = form.qindex.rowset.fields["unique"]
      columns["COLUMN5"].editorType = 2	// CheckBox
      columns["COLUMN5"].width = 15
      with (columns["COLUMN1"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN1"].headingControl)
         fontSize = 8
         value = "Name"
      endwith

      with (columns["COLUMN2"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN2"].headingControl)
         fontSize = 8
         value = "Expression"
      endwith

      with (columns["COLUMN3"].editorControl)
         fontSize = 8
      endwith

      with (columns["COLUMN3"].headingControl)
         fontSize = 8
         value = "forExpression"
      endwith

      with (columns["COLUMN4"].editorControl)
         colorHighLight = "WindowText/Window"
      endwith

      with (columns["COLUMN4"].headingControl)
         fontSize = 8
         value = " D"
      endwith

      with (columns["COLUMN5"].editorControl)
         colorHighLight = "WindowText/Window"
      endwith

      with (columns["COLUMN5"].headingControl)
         fontSize = 8
         value = " U"
      endwith

      bgColor = "white"
      cellHeight = 18
      allowEditing = false
      allowAddRows = false
      pageno = 3
      height = 213
      left = 6
      top = 30
      width = 374
   endwith

   this.NB.EDITOR1 = new EDITOR(this.NB)
   with (this.NB.EDITOR1)
      height = 168
      left = 6
      top = 33
      width = 374
      value = ""
      fontName = "Courier New"
      pageno = 4
   endwith

   this.NB.TEXTLABEL1 = new LABELBC(this.NB)
   with (this.NB.TEXTLABEL1)
      left = 10
      top = 204
      width = 60
      text = "Table Name"
      pageno = 4
   endwith

   this.NB.EFTABLE = new ENTRYFIELD(this.NB)
   with (this.NB.EFTABLE)
      height = 20
      left = 10
      top = 220
      width = 100
      fontSize = 8
      value = ""
      pageno = 4
   endwith

   this.NB.CBDELIMIT = new CHECKBOX(this.NB)
   with (this.NB.CBDELIMIT)
      height = 16
      left = 117
      top = 219
      width = 90
      text = "Fully Delimited"
      fontSize = 8
      pageno = 4
   endwith

   this.NB.PBCREATE = new PUSHBUTTON(this.NB)
   with (this.NB.PBCREATE)
      onClick = class::PBCREATE_ONCLICK
      height = 36
      left = 258
      top = 207
      width = 120
      text = "Generate Create Table Statement"
      upBitmap = "RESOURCE:2 PS_RUN"
      fontSize = 8
      pageno = 4
   endwith


   function qField_canOpen
   ***********************
   *- Purpose: Create table to open

      with (this.fields)
         add("Name C32")
         add("Type C10")
         add("Length N3,0")
         add("Decimal N2,0")
         add("SqlType C20")
      endwith

      this.createTable()

      return TMPQuery::canOpen()

   function qIndex_canOpen
   ***********************
   *- Purpose: Create table to open

      with (this.fields)
         add("Name C32")
         add("Express C220")
         add("forExpress C220")
         add("Descend B")
         add("Unique B")
         add("Type N1,0")
      endwith

      this.createTable()

      return TMPQuery::canOpen()

   function qReport_canOpen
   ************************
   *- Purpose: Create table to open

      with (this.fields)
         add("GKey C1")
         add("Text1 C32")
         add("Text2 C220")
         add("Text3 C32")
         add("Text4 C3")
         add("Text5 C3")
      endwith

      this.createTable()

      return TMPQuery::canOpen()

   function Open
   *************
   *- Purpose: Custom initialization

      // Custom properties
      this.params    = new AssocArray()
      this.report    = null
      this.tableDef  = null

      // Disable access
      with (this.nb)
         PBView.enabled		= false
         PBPrint.enabled	= false
         PBCreate.enabled  = false
      endwith

      this.nb.GetTable1.beforeOpen()

      return super::open()

	function onOpen
   ***************
   *- Purpose: Process openTable if appropriate
		// 		openTable is tableName passed when opening form

   	if TYPE("this.openTable") == "C"
      	local cFile, nAt, cPath

         cFile = this.openTable
         nAt	= cFile.lastIndexOf("\")

         // Check for path, add if not exist
         if nAt < 0
         	cPath = SET("DIRECTORY") + "\"
            cFile = cPath + cFile
         endif

         // check for extension, add if not exist
         if UPPER(cFile.right(4)) # ".DBF"
            cFile += ".dbf"
         endif

         this.nb.getTable1.processFile(cFile)

      endif
      return

   function GetTable1_onChange(cFile, cPath, cAlias)
   ***************************
   *- Purpose: Update controls for table change
      //       Fired by GetTable Class
   *- Params:  cFile - Table name returned by GetTable
      //       cPath - Path returned by GetTable
      //       cAlias - Alias name returned by GetTable

      try
         local bDBF
         bDBF = false

         this.tableDef = new tableDef()

         if NOT EMPTY(cALIAS)
            this.database.active       = false
            this.database.databaseName = cAlias
            this.database.active       = true
            this.tableDef.database     = this.database
            this.tableDef.tableName    = cFile
         else
            this.tableDef.tableName = cPath + "/" + cFile
         endif

         this.tableDef.load()

         this.params['TableName']   = cFile
         this.params['Path']        = cPath
         this.params['Alias']       = cAlias
         this.params['PrimaryKey']  = this.tableDef.primaryKey
         this.params['Language']    = this.tableDef.language
         this.params['TypeVersion'] = this.tableDef.tableType.rightTrim() +;
                                      " / " + this.tableDef.version
         this.params['RowCount']    = this.tableDef.recordCount
         this.params['Converted']   = null

         if this.tableDef.tableType = "DBASE"
            bDBF = this.loadDBF()

   		else
         	this.qField.emptyTable()
            this.qIndex.emptyTable()
				MSGBOX("Limited Information Available", "Expecting DBF", 48)

         endif

         this.updateControls(bDBF)

      catch(exception e)
         MSGBOX(e.message, "Load Error", 16)

      finally
         this.database.active = false
         this.tableDef = null
      endtry

      return

   function UpdateControls(bEnable)
   ***********************
   *- Purpose: Update form controls
   *- Params:  bEnable - Whether to enable certain controls

      local cTable
      cTable = this.params['TableName']
      cTable = cTable.substring(0, cTable.length - 4)

      with (this.NB)               
         DLabel1.text      = " " + this.params['TypeVersion']
         DLabel2.text      = " " + this.params['Language']
         DLabel3.text      = " " + this.params['PrimaryKey']
         DLabel4.text      = " " + this.params['RowCount']
         DLabel5.text      = " " + this.params['TableName']
         PBView.enabled		= bEnable
         PBPrint.enabled	= bEnable
         CBConvert.value   = this.params['Converted']
         PBCreate.enabled  = bEnable
         Editor1.value     = ""
         EFTable.value     = cTable
         CBDelimit.value   = false
      endwith
      return

   function LoadDBF
   ****************
   *- Purpose: Load tableDef field and index info
      //       Field info stored in field table
      //       Index info stored in index table

      try
         local bLoad, bConvert, i, cType, nLen, nDec
         bLoad = true

         this.qField.rowset.notifyControls = false
         this.qIndex.rowset.notifyControls = false
         this.qField.emptyTable()
         this.qIndex.emptyTable()

         // Field Information
         bConvert = false
         i = 1

         do while i <= this.tableDef.fields.size
            if this.tableDef.fields[i].fieldName # "_DBASELOCK"
               cType = this.tableDef.fields[i].type
               nLen  = this.tableDef.fields[i].length
               nDec  = this.tableDef.fields[i].decimalLength

               with(this.qField.rowset)
                  beginappend()
                  fields["Name"].value    = this.tableDef.fields[i].fieldName
                  fields["Type"].value    = PROPER(cType)
                  fields["Length"].value   = nLen
                  fields["Decimal"].value = nDec
                  fields["SQLType"].value = this.DBFtoSQL(cType, nLen, nDec)

                  parent.rowset.save()
               endwith

            else
               bConvert = true
            endif
            i += 1
         enddo

         // Index Information
         i = 1
         do while i <= this.tableDef.indexes.size
            with(this.qIndex.rowset)
               beginappend()
               fields["Name"].value          = this.tableDef.indexes[i].indexName
               fields["Express"].value    = this.tableDef.indexes[i].expression
               fields["forExpress"].value = this.tableDef.indexes[i].forExpression
               fields["Descend"].value       = this.tableDef.indexes[i].descending
               fields["Unique"].value        = this.tableDef.indexes[i].unique
               fields["Type"].value          = this.tableDef.indexes[i].type

               parent.rowset.save()
            endwith

            i += 1
         enddo

         this.params['Converted']   = bConvert

      catch(exception e)
         local cMsg
         cMsg  = "Cannot Load Fields or Indexes" + chr(13)
         cMsg += e.message
         MSGBOX(cMsg, "Load Error", 16)

         this.qField.emptyTable()
         this.qIndex.emptyTable()

         bLoad = false

      finally
         this.qField.rowset.notifyControls = true
         this.qIndex.rowset.notifyControls = true

         this.qField.rowset.first()
         this.qIndex.rowset.first()

      endtry
      return bLoad

   function DBFtoSQL(cType, nLen, nDec)
   *****************
   *- Purpose: Return SQL field type from dbf field params
   *- Params:  cType - dbf field type
      //       nLen  - dbf field length
      //       nDec  - dbf field decimal length
         
      local cSql, cLen, cDec
      cLen = STR(nLen).leftTrim()
      cDec = STR(nDec).leftTrim()

      do case
      case cType == "CHARACTER"
         cSql = "Char(" + cLen + ")"
      case cType == "NUMERIC"
         cSql = "Numeric(" + cLen + "," + cDec + ")"
      case cType == "LOGICAL"
         cSql = "Boolean"
      case cType == "DATE"
         cSql = "Date"
      case cType == "AUTOINC"
         cSql = "Autoinc"
      case cType == "DATETIME"
         cSql = "Timestamp"
      case cType == "LONG"
         cSql = "Integer"
      case cType == "DOUBLE"
         cSql = "Float(" + cLen + "," + cDec + ")"
      case cType == "MEMO"
         cSql = "Blob(0,1)"
      case cType == "BINARY"
         cSql = "Blob(0,2)"
      case cType == "OLE"
         cSql = "Blob(0,4)"
      otherwise
         cSql = Proper(cType)
      endcase
      return cSql

   function PBCreate_onClick
   *************************
   *- Purpose: Generate create table statement

      local rField, fField
      rField = form.qField.rowset
      fField = form.qField.rowset.fields

      local cTable, bDelimit, cDelimit, cValue, cName, cType
      cTable   = form.nb.efTable.value
      bDelimit = form.nb.cbDelimit.value
      cDelimit = ""
      cValue   = "No Table Fields Loaded"

      if rField.first()

         if EMPTY(cTable)
            cTable = "MyTable"
         endif

         if bDelimit
            cDelimit = ['']
         endif

         cValue = [Create Table "] + cTable + [" (;] + chr(13)

         do
            cName = fField['Name'].value.rightTrim()
            cType = fField['SQLType'].value.rightTrim()

            cValue += chr(9)  // Tab

            if bDelimit
               cValue += cDelimit.stuff(1, 0, cTable) + "."
            endif

            cValue += cDelimit.stuff(1, 0, cName) + " " + cType + [,;]
            cValue += chr(13) // Return

         until NOT rField.next()

         cValue = cValue.stuff(cValue.length - 3, 2, ")")
         rField.first()
      endif

      form.nb.editor1.value = cValue

      return

   function Report_onClick
   ***********************
   *- Purpose: Build report table and run report

      local rSource, fSource, nOutput
      local cExpress, cFor, cDescend, cUnique
      local cName, nExtent, nWidthB, nWidthC

      if form.report = null
         form.report = new DBFDefReport()
      else
         form.report.close()
      endif

      if NOT form.qReport.active
         // create table, query setup
         form.qReport.active = true
         form.params['ReportTable'] = form.qReport.fullPath
      else
         form.qReport.emptyTable()
      endif

      rSource	= form.qField.rowset
      fSource	= form.qField.rowset.fields

      nOutput	= IIF(this.name = "PBVIEW", 0, 1)

      nWidthB	= 0 
      nWidthC	= 0 

      with (form.qReport.rowset)
         beginAppend()
         fields['GKey'].value    = "A"
         fields['Text1'].value   = form.params['TypeVersion']
         fields['Text2'].value   = form.params['Language']
         fields['Text3'].value   = form.params['PrimaryKey']
         fields['Text4'].value   = IIF(form.params['Converted'], "Yes", Null)
         parent.rowset.save()
      endwith

      if rSource.first()
         do
         	cName		= fSource['Name'].value.rightTrim()
            nExtent	= INT(form.gte.getTextExtent(cName) * 0.75)

            if nExtent > nWidthB
            	nWidthB = nExtent
            endif

            with (form.qReport.rowset)
               beginAppend()
               fields['GKey'].value    = "B"
               fields['Text1'].value   = cName
               fields['Text2'].value   = fSource['Type'].value
               fields['Text3'].value   = fSource['SQLType'].value
               fields['Text4'].value   = STR(fSource['Length'].value).leftTrim()
               fields['Text5'].value   = STR(fSource['Decimal'].value).leftTrim()
               parent.rowset.save()
            endwith

         until NOT rSource.next()
      endif

      rSource = form.qIndex.rowset
      fSource = form.qIndex.rowset.fields

      if rSource.first()
         do

         	cName		= fSource['Name'].value.rightTrim()
            nExtent	= INT(form.gte.getTextExtent(cName) * 0.75)

            if nExtent > nWidthC
            	nWidthC = nExtent
            endif

				cExpress	= fSource['Express'].value.rightTrim()
            cFor		= fSource['forExpress'].value.rightTrim()
            cDescend = iif(fSource['Descend'].value, "Yes", null)
            cUnique  = iif(fSource['Unique'].value, "Yes", null)

				if NOT EMPTY(cFor)
            	cFor = "{}".stuff(1, 0, cFor)
               if LEN(cExpress + cFOR) < 50
               	cExpress += " " + cFor
                  cFor		 = Null
               endif
            endif

            with (form.qReport.rowset)
               beginAppend()
               fields['GKey'].value    = "C"
               fields['Text1'].value   = cName
               fields['Text2'].value   = cExpress
               fields['Text4'].value   = cDescend
               fields['Text5'].value   = cUnique
               parent.rowset.save()
            endwith

            if NOT EMPTY(cFor)
               with (form.qReport.rowset)
                  beginAppend()
                  fields['GKey'].value    = "C"
                  fields['Text2'].value	= cFor
                  parent.rowset.save()
               endwith
            endif
                        	
         until NOT rSource.next()
      endif

      form.report.params = new AssocArray()
      form.report.params['Title2']	= form.params['TableName']
      form.report.params['Table']	= form.params['ReportTable']
      form.report.params['WidthB']	= nWidthB
      form.report.params['WidthC']	= nWidthC

      form.report.output = nOutput
      form.report.render()

      return

   function Release
   ****************
   *- Purpose: Cleanup

      // Cleanup Report
      if this.report # null
         this.report.close()
         this.report.release()
         this.report = null
      endif

      // Deactivate queries to fire query onClose
      // Necessary for dropping temporary tables
      this.qField.active   = false
      this.qIndex.active   = false
      this.qReport.active  = false

      // Close databases
      this.database.active = false

      return super::release()

endclass
//
//
Class TMPQuery of Query custom
*----------------------
*- Name.....Temporary Table Query
*- Author...Todd Kreuter
*- For......dB2K, 7.5, 7.01
*- Usage....myQuery = new TMPQuery()

*- Description
   // For creating and working with temporary tables

   // Table is created using the the internal fields array,
   // Fields are added to the fields array using the arrays
   // Add(cField, bSQL) mehtod (See internal mehtod notes).

   // Can Use Short Hand syntax or standard SQL syntax
   // for creating fields. If the Short Hand syntax is used,
   // fields are automatically delimited, so there is no need
   // to manually delimit any thing when creating field names
   // containing spaces or SQL reserved keywords, and when
   // using tableNames which need to be delimited.

*- Special Notes
   // Only tested with Level 7 DBF Tables
   // Do not assign a database to these queries

*- Aknowledgements
// Gary White	-	Database methods can be used on tables
	//					located outside of the database path, if we
   //					provide the tables fullPath to those methods.
   //					API Code for retreiving OS Temporary path (NG)

*- Custom Properties
// TableName	-	Name of table
// useTempPath	-	Determine if table is created in the OS 
	//					temporary directory, default is true.
   //					Set to false to create in current directory.
// dropOnClose	-	Delete table when query closed
   //					Only Works when setting query.active = false
   //             Temporarily disabled when query is deactived
   //             by custom methods (emptyTable, createIndex)

*- Custom Methods
// CreateTable	- Creates table from fields array
// CreateIndex	- Creates Index Tag (tagName, tagExpression)
// EmptyTable	- Zaps table, reactivates query if active
// DropTable	- Deletes table

*- Internal Properties
// fullPath	- String containing full path necessary to locate
	//			  the table, being the path + the tableName.
// fields	- Array containing fields list for createTable

*- Internal Methods
// AddField	-	Overridden fields array Add() Method
   //		  		Call fields.add(cField, <bSQL>) method
   //         	cField can be Short Hand syntax, "Name C30"
   //         	cField can be SQL Syntax "Name Char(30)"

   //         	Short Hand is the default, so when using
   //         	SQL syntax, bSQL must be true to bypass
   //         	the short hand converstion

*- Internal Events
// canOpen	-	Sets sql statement for fullPath
// onClose	-	Delete table if dropOnClose is true

*- History
// 2001.0121 -	Original, adapted from RMFlat Class
// 2001.0201 -	Added Short Hand data type conversion
// 2001.0203 -	Improved error handling, messages
// 2001.0501 -	Disable canOpen event when internally
   //			 	reopening query
// 2001.0517 -	Added useTempPath property
   //				Added fullPath property, getFullPath method
   //				Included API call to retreive temporary path

*----------------

   // Custom
   this.tableName		= FUNIQUE("_TMP????")
	this.useTempPath	= true
   this.dropOnClose	= true

   // Internal
   this.fullPath		= this.tableName
   this.fields       = new array()
   this.fields.add   = class::addField

   function canOpen
   ****************
      this.sql	= [Select * from '] + this.fullPath + [']
      return true

   function onClose
   ****************
      if this.dropOnClose
         this.dropTable()
      endif
      return

   function AddField(cField, bSQL)
   *****************
   * - cField, field Definition
   * - bSQL, cField is in SQL Syntax (no conversion)

      if bSQL
         return ARRAY::ADD(cField)
      endif

      local nAt, cName, cType, cMap, cSql

      nAt   = cField.LastIndexOf(" ")
      cName = cField.left(nAt).rightTrim()
      cType = cField.right(cField.length - nAt).leftTrim()
      cMap  = cType.left(1)
      cSql  = null

      // Get SQL Data Type
      do case
      case cMap = "C"   // Character(n)
         cSql = "Char("

      case cMap = "N"   // Numeric(x,y)
         cSql  = "Numeric("

      case cMap = "D"   // Date
         cSql = "Date"

      case cMap = "B"   // Boolean<logical>
         cSql = "Boolean"

      case cMap = "A"   // Autoincrement
         cSql = "AutoInc"

      case cMap = "T"   // Timestamp
         cSql = "TimeStamp"

      case cMap = "L"   // Long Integer
         cSql = "Integer"

      case cMap = "S"   // Small Integer
         cSql = "SmallInt"

      case cMap = "F"   // Float(x,y)
         cSql = "Float("

      case cMap = "O"   // BLOB(n,t)
         cSQL = "BLOB("

      otherWise
         local cMsg
         cMsg  = "Invalid Data Type Conversion!" + chr(13)
         cMsg += "Field Name: " + cName + chr(13)
         cMsg += "Short Hand: " + cType + chr(13)

         MSGBOX(cMsg, "Cannot Add Field", 48)

      endcase

      if cSQL # Null

         // Substitue SQL Type
         cType = cType.stuff(0, 1, cSql)

         if cType.indexOf("(") > 0
            cType += ")"
         endif

         // Field Definition string
         cField = [''.'] + cName + [' ] + cType

         return ARRAY::ADD(cField)

      endif
      return

   function CreateTable
   ********************
      try

			this.setFullPath()

         local bCreate, i, cField
         private cMacro
         bCreate = true
         i = 0

         if this.fields.size = 0
            THROW Exception
         endif

         if this.database.tableExists(this.fullPath)
            this.database.dropTable(this.fullPath)
         endif

         cMacro   = [create table "] + this.fullPath + [" (]

         for i = 1 to this.fields.size

            if this.fields[i].left(2) = "''"
               // Short Hand Syntax, insert tableName 
               cField = this.fields[i].stuff(1, 0, this.tableName)

            else
               // SQL Syntax
               cField = this.fields[i]
            endif

            cMacro += cField

            if i # this.fields.size
               cMacro += ", "
            endif

         endfor

         cMacro += ")"

         &cMacro.

      catch(exception e)
         bCreate = false
         local cMsg

         if i = 0
            cMsg = "Expecting at Least One Field Definition!"
         else
            cMsg  = e.message
         endif

         MSGBOX(cMsg, "Cannot Create Table", 16)

      endtry

      return bCreate

   function CreateIndex(tagName, tagExpression)
   ********************
      try

         local bCreate, bDrop, bActive, pCanOpen, dIndex
         bCreate = true

         if PCOUNT() = 1
            // Assume one field tag
            tagExpression = tagName
         endif

         bDrop    = this.dropOnClose
         bActive  = this.active
         pCanOpen = this.canOpen

         this.dropOnClose  = false
         this.active       = false
         this.canOpen      = null

         dIndex = new DBFIndex()
         dIndex.indexName  = tagName
         dIndex.expression = tagExpression
         this.database.createIndex(this.fullPath, dIndex)

         this.active       = bActive
         this.dropOnClose  = bDrop
         this.canOpen      = pCanOpen

      catch(exception e)
         bCreate = false

         local cMsg
         cMsg  = e.message + chr(13)
         cMsg += "Tag Name  : " + tagName + chr(13)
         cMsg += "Expression: " + tagExpression

         MSGBOX(cMsg, "Cannot Create Index", 16)

      endtry
      return bCreate


   function EmptyTable
   *******************
      try
         local bDrop, bActive, pCanOpen

         bDrop    = this.dropOnClose
         bActive  = this.active
         pCanOpen = this.canOpen

         this.dropOnClose  = false
         this.active       = false
         this.canOpen      = null

         this.database.emptyTable(this.fullPath)

         this.active       = bActive
         this.dropOnClose  = bDrop
         this.canOpen      = pCanOpen

         this.rowset.refreshControls()

      catch(exception e)
         MSGBOX(e.message, "Cannot Empty Table", 48)

      endtry
      return

   function DropTable
   ******************
      try
         this.active = false
         this.database.dropTable(this.fullPath)

      catch(exception e)
         MSGBOX(e.message, "Cannot Delete Table", 16)

      endtry
      return

	function setFullPath
   ********************
   	local cPath, nLen, n

      if this.useTempPath

         if type("GetTempPath") # "FP"
            extern culong GetTempPath(culong, cstring) kernel32 ;
            from "GetTempPathA"
         endif

         cPath	= SPACE(256)
         nLen	= cPath.length
         n		= GetTempPath(nLen, cPath)

         if n > nLen
            nLen	= n
            n		= GetTempPath(nLen, cPath)
         endif

         if n > 0
            cPath	= cPath.left(nLen)
         else
            cPath	= SET("Directory")
         endif

      else
         cPath = SET("Directory") + "\"

      endif

      this.fullPath = cPath + this.tableName

	  	return

endclass
//
class getTable(parentObj) of CONTAINER(parentObj) custom
*------------------------
*- Name.....Get Table Control
*- Author...Todd Kreuter
*- For......dB2K
*- Usage....form drop custom control
   //       call beforeOpen method to instantiate

*- Description
   // Allows for selecting table using standard getFile
   // dialog or drag and drop.  Uses tableExists method to
   // ensure table was selected.

   // When table is selected, internal properties are updated
   // with parsed information (tableName, path, alias) and a
   // call is made to the custom onChange event.

*- Aknowledgements
// Gary White  -  Database methods can be used on tables
   //             located outside of the database path, if we
   //             provide the tables fullPath to those methods.

*- Custom Properties
// stripExt    - If extension is striped from tableName
// fileMask    - File mask for getFile dialog (Default *.dbf)

*- Custom Events
// onChange -  Event fired after table is selected.  Upon
   //          instantiation, a check is made for a function
   //          pointer in the form named controlName_onChange.
   //          If one exists, a codeblock is assinged to the
   //          onChange which will call that function, passing
   //          the tableName, path, and alias.  Alternatively,
   //          you can assign your own codeblock.

   //          Example of function to include in form:
   //          function getTable1_onChange(cFile, cPath, cAlias)

*- Internal Properties
// TableName   - Name of table selected
// Path        - Path where table was selected
// Alias       - Alias name where table was selected

*- Internal Events
// onDrop         - File droped on container
// Button_onClick - Button clicked, calls getFile dialog

*- Internal Methods
// beforeOpen  - Required to instantiate all controls
// ProcessFile - Processes file from drag/drop or GetFile()

*- History
// 2001.0121 - Original
// 2001.0501 - Overhaul for dB2k (drag n drop)
// 2001.0504 - Code to ensure table was selected
// 2001.0522 - Restore environment for database change

*----------------
   with (this)
      width = 340
      height = 88
      metric = 6  // Pixels
      allowDrop = true
   endwith

   // Custom properties
   this.stripExt  = false
   this.fileMask  = "*.dbf"

   // Custom events
   this.onChange  = {||Null}

   // Internal properties
   this.tableName = null
   this.path      = null
   this.alias     = null

   function beforeOpen
   *******************
   *- Purpose: Prevent instantiation until called
      //       Call in overriden open mehtod

      this.LABEL1 = new LABELBC(this)
      with (this.LABEL1)
         left  = 4
         top   = 14
         width = 60
         text  = "Table Name"
      endwith

      this.LABEL2 = new LABELBC(this)
      with (this.LABEL2)
         left  = 4
         top   = 36
         width = 60
         text  = "Path"
      endwith

      this.LABEL3 = new LABELBC(this)
      with (this.LABEL3)
         left  = 4
         top   = 58
         width = 60
         text  = "Alias"
      endwith

      this.DLTable = new EntryNA(this)
      with (this.DLTable)
         left     = 66
         top      = 10
         width    = 180
      endwith

      this.DLPath = new EntryNA(this)
      with (this.DLPath)
         left     = 66
         top      = 32
         width    = 180
      endwith

      this.DLAlias = new EntryNA(this)
      with (this.DLAlias)
         left     = 66
         top      = 54
         width    = 180
      endwith

      this.BUTTON = new PUSHBUTTON(this)
      with (this.BUTTON)
         onClick     = class::Button_onClick
         height      = 18
         left        = 228
         top         = 11
         width       = 16
         text        = ""
         upBitmap    = "RESOURCE #144"
         speedBar    = true
         borderStyle = 4   // Single
      endwith

      // Setup onchange event
      private cMacro

      if type("this.form." + this.name + "_onChange") = "FP"
         cMacro  = "{;this.form." + this.name + "_onChange"
         cMacro += "(this.tableName, this.path, this.alias)}"
         this.onChange = &cMacro
      endif

      return

   function onDrop(nLeft, nTop, cType, cFile)
   ***************
   *- Purpose: Provide drag and drop capability
   *- Params:  Standard for event

      if cType == "F"
         this.form.setFocus()
         this.processFile(cFile)
      endif
      return false

   function Button_onClick
   ***********************
   *- Purpose: Provide standard getFile dialog

      local cSetDB, cFile
      cSetDB   = SET("Database")
      cFile    = GetFile(this.parent.fileMask, "Select Table", false)

      if not EMPTY(cFile)

         // Include for repaint problem
         if type( "UpdateWindow" ) # "FP"
            extern CLOGICAL UpdateWindow( CHANDLE ) USER32
         endif
         UpdateWindow( form.hWnd )

         this.parent.processFile(cFile)
      endif

      // Restore Environment for database
      if cSetDB # SET("Database")
         SET DATABASE TO (cSetDB)
      endif

      return

   function ProcessFile(cFile)
   ********************
   *- Purpose: Process cFile from drag/drop or getFile
      //       parse information, determine if valid table,
      //       update visual controls, fire onChange

      local cPath, cAlias, nLen, bTable, nAt

      cPath    = null
      cAlias   = null
      nLen     = cFile.length
      bTable   = false

      if cFile.left(1) = ":"
         nAt      = cFile.indexOf(":", 1)
         cAlias   = cFile.subString(1, nAt)
         cFile    = cFile.subString(nAt + 1, nLen)
         bTable   = new database(cAlias).tableExists(cFile)

      else
         nAt      = cFile.lastIndexOf("\")
         bTable   = _app.databases[1].tableExists(cFile)
         cPath    = cFile.subString(0, nAt)
         cFile    = cFile.subString(nAt + 1, nLen)
      endif

      if bTable

         if this.stripExt
            nAt   = cFile.indexOf(".")
            cFile = cFile.subString(0, nAt)
         endif

         // update visual controls
         this.DLTable.value   = cFile
         this.DLPath.value    = cPath
         this.DLAlias.value   = cAlias

         this.tableName = cFile
         this.path      = cPath
         this.alias     = cAlias

         this.onChange()

      else
         local cMsg
         cMsg   = "Selcted File Not a Valid Table!" + CHR(13)
         cMsg  += "File Name: " + cFile
         MSGBOX(cMsg, "Canceled", 48)
      endif

      return bTable

endclass
//
class DBFDefReport of REPORT
   with (this)
      render = class::RENDER
      close = class::CLOSE
      metric = 2	// Points
      autoSort = false
   endwith

   this.QITEM = new QUERY()
   this.QITEM.parent = this
   with (this.QITEM)
      canOpen = class::QITEM_CANOPEN
      sql = "select * from DBFDef.dbf"
      requestLive = false
   endwith

   this.SSOURCE = new STREAMSOURCE(this)
   this.SSOURCE.GROUP1 = new GROUP(this.SSOURCE)
   with (this.SSOURCE.GROUP1)
      groupBy = "GKey"
      headerEveryFrame = true
   endwith

   with (this.SSOURCE.GROUP1.headerBand)
      preRender = class::HEADERBAND_PRERENDER
      height = 30
   endwith

   this.SSOURCE.GROUP1.headerBand.TITLE1 = new TEXTLABEL(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.TITLE1)
      height = 14
      left = 0
      top = 0
      width = 80
      text = "Table"
      fontSize = 12
      fontBold = true
   endwith

   this.SSOURCE.GROUP1.headerBand.LABEL1 = new RLABELA10(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LABEL1)
      left = 0
      top = 14
      width = 60
      text = "Type/Version"
   endwith

   this.SSOURCE.GROUP1.headerBand.LABEL2 = new RLABELA10(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LABEL2)
      left = 105
      top = 14
      width = 80
      text = "Language"
   endwith

   this.SSOURCE.GROUP1.headerBand.LABEL3 = new RLABELA10(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LABEL3)
      left = 210
      top = 14
      width = 80
      text = "Primary Key"
   endwith

   this.SSOURCE.GROUP1.headerBand.LABEL4 = new RLABELA10(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LABEL4)
      left = 315
      top = 14
      width = 40
      text = "Converted"
      alignHorizontal = 2	// Right
   endwith

   this.SSOURCE.GROUP1.headerBand.LABEL5 = new RLABELA10(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LABEL5)
      left = 370
      top = 14
      width = 40
      text = ""
      alignHorizontal = 2	// Right
   endwith

   this.SSOURCE.GROUP1.headerBand.LINE1 = new LINE(this.SSOURCE.GROUP1.headerBand)
   with (this.SSOURCE.GROUP1.headerBand.LINE1)
      left = 0
      right = 365.25
      top = 26.25
      bottom = 26.25
      width = 1
   endwith

   with (this.SSOURCE.GROUP1.footerBand)
      height = 10
   endwith

   this.SSOURCE.detailBand.TEXT1 = new RTEXTA10(this.SSOURCE.detailBand)
   with (this.SSOURCE.detailBand.TEXT1)
      left = 0
      top = 2
      width = 100
      text = {||this.form.qitem.rowset.fields["text1"].value}
   endwith

   this.SSOURCE.detailBand.TEXT2 = new RTEXTA10(this.SSOURCE.detailBand)
   with (this.SSOURCE.detailBand.TEXT2)
      left = 105
      top = 2
      width = 100
      text = {||this.form.qitem.rowset.fields["text2"].value}
   endwith

   this.SSOURCE.detailBand.TEXT3 = new RTEXTA10(this.SSOURCE.detailBand)
   with (this.SSOURCE.detailBand.TEXT3)
      left = 210
      top = 2
      width = 100
      text = {||this.form.qitem.rowset.fields["text3"].value}
   endwith

   this.SSOURCE.detailBand.TEXT4 = new RTEXTA10(this.SSOURCE.detailBand)
   with (this.SSOURCE.detailBand.TEXT4)
      left = 315
      top = 2
      width = 40
      alignHorizontal = 2	// Right
      text = {||this.form.qitem.rowset.fields["text4"].value}
   endwith

   this.SSOURCE.detailBand.TEXT5 = new RTEXTA10(this.SSOURCE.detailBand)
   with (this.SSOURCE.detailBand.TEXT5)
      left = 370
      top = 2
      width = 40
      alignHorizontal = 2	// Right
      text = {||this.form.qitem.rowset.fields["text5"].value}
   endwith

   this.PAGETEMPLATE1 = new PAGETEMPLATE(this)
   with (this.PAGETEMPLATE1)
      height = 792
      width = 612
      marginTop = 36
      marginLeft = 54
      marginBottom = 36
      marginRight = 36
      gridLineWidth = 0
   endwith

   this.PAGETEMPLATE1.SFRAME = new STREAMFRAME(this.PAGETEMPLATE1)
   with (this.PAGETEMPLATE1.SFRAME)
      height = 656
      left = 0
      top = 45
      width = 518
   endwith

   this.PAGETEMPLATE1.TITLE1 = new TEXTLABEL(this.PAGETEMPLATE1)
   with (this.PAGETEMPLATE1.TITLE1)
      height = 14
      left = 0
      top = 0
      width = 150
      text = "Table Definition Report"
      fontSize = 12
      fontBold = true
   endwith

   this.PAGETEMPLATE1.TITLE2 = new TEXTLABEL(this.PAGETEMPLATE1)
   with (this.PAGETEMPLATE1.TITLE2)
      height = 14
      left = 0
      top = 16
      width = 150
      text = "Table Name"
      fontSize = 12
      fontBold = true
   endwith

   this.PAGETEMPLATE1.DLABEL9 = new RLABELA10(this.PAGETEMPLATE1)
   with (this.PAGETEMPLATE1.DLABEL9)
      left = 418
      top = 0
      width = 100
      text = "Field9"
      alignHorizontal = 2	// Right
   endwith

   this.firstPageTemplate = this.form.pagetemplate1
   this.form.pagetemplate1.nextPageTemplate = this.form.pagetemplate1
   this.form.pagetemplate1.sframe.streamSource = this.form.ssource
   this.form.ssource.rowset = this.form.qitem.rowset

   function qItem_canOpen
   **********************
      if TYPE("this.parent.params") == "O"
         this.sql = [Select * from '] + this.parent.params['Table'] + [']
      endif
      return true

   function Render
   ***************
   *- Purpose: Custom initialization
   *- Notes:   Requires params pass prior to render()

      if type("this.params") == "O"

      	local nMin
         nMin = 60

      	// Adjust width params for minimum width
         if this.params['WidthB'] < nMin
         	this.params['WidthB'] = nMin
         endif

         if this.params['WidthC'] < nMin
         	this.params['WidthC'] = nMin
         endif

      	// Adjust width params for maximum width
         if this.params['WidthB'] > 140
         	this.params['WidthB'] = 140
         endif

         if this.params['WidthC'] > 140
         	this.params['WidthC'] = 140
         endif

			// Convert to offset numbers
         this.params['WidthB'] -= nMin
         this.params['WidthC'] -= nMin

         this.qItem.active = true

         with (this.PageTemplate1)
         	Title2.text		= this.params['Title2']
            DLabel9.text   = new date().tolocaleString()
         endwith
      endif

      return super::Render()

   function HeaderBand_preRender
   ****************************
   *- Purpose: Change text and position of controls
      //       depending on header type (field or index)

		local nOffset

      do case
      case this.parent.parent.rowset.fields['GKey'].value = "A"
         with (this.parent.headerBand)
            title1.text = ""
            label1.text = "Type/Version"
            label2.text = "Language"
            label3.text = "Primary Key"
            label4.text = "Converted"
            label5.text = ""

				label2.left	= 105
            label3.left = 210
            label4.left = 315
            label5.left = 360

				label2.width = 80

            line1.right = 355
         endwith

         with (this.parent.parent.detailBand)
				text2.left		= 105
            text3.left  	= 210
            text4.left  	= 315
            text5.left  	= 360

				text1.width		= 100
            text2.width 	= 100
            text3.width 	= 100

         endwith

      case this.parent.parent.rowset.fields['GKey'].value = "B"
      	nOffset = this.parent.parent.parent.params['WidthB']
         with (this.parent.headerBand)
            title1.text = "Fields"
            label1.text = "Name"
            label2.text = "Type"
            label3.text = "SQL Type"
            label4.text = "Length"
            label5.text = "Decimal"

				label2.left	=  85 + nOffset
            label3.left = 295 + nOffset
            label4.left = 170 + nOffset
            label5.left = 215 + nOffset

				label2.width = 80

            line1.right = 375 + nOffset
         endwith

         with (this.parent.parent.detailBand)
				text2.left 	=  85 + nOffset
            text3.left 	= 295 + nOffset
            text4.left 	= 170 + nOffset
            text5.left 	= 215 + nOffset

				text1.width	=  80 + nOffset
            text2.width	=  80
            text3.width	=  80

         endwith

      case this.parent.parent.rowset.fields['GKey'].value = "C"
      	nOffset = this.parent.parent.parent.params['WidthC']
         with (this.parent.headerBand)
            title1.text = "Indexes"
            label1.text = "Name"
            label2.text = "Expression {forExpression}"
            label3.text = ""
            label4.text = "Descend"
            label5.text = "Unique"

				label2.left	= 85 + nOffset
            label3.left = 260
            label4.left = 415
            label5.left = 460

				label2.width = 120

            line1.right = 500
         endwith

         with (this.parent.parent.detailBand)
				text2.left	=  85 + nOffset
            text3.left 	= 410
            text4.left 	= 415
            text5.left 	= 460

				text1.width	=  80 + nOffset
            text2.width	= 320 - nOffset
            text3.width	= 0

         endwith
      endcase
      return

   function Close
   **************
   *- Purpose: Cleanup references

      this.qItem.active = false
      this.params       = null

      return super::Close()
endclass
//
class RLabelA10(parentObj) of TextLabel(parentObj) custom
***************
*- 2001.05.04
   with (this)
   	height = 10
      width = 50
      metric = 2	// Points
      fontSize = 10
      text = "Label"
   endwith

endclass
//
class RTextA10(parentObj) of Text(parentObj) custom
**************
*- 2001.05.04
   with (this)
   	height = 10
      width = 50
      metric = 2	// Points
      variableHeight = true
      prefixEnable = false
      fontSize = 10
      text = "Text"
   endwith

endclass
//
Class LabelBC(parentObj) of TextLabel(parentObj) custom
*************
*- Label, Base Class
*- 2001.0720
   with (this)
      height	= 14
      width		= 50
      metric	= 6	// Pixels
      fontSize	= 8
      text		= "Label"
   endwith
endclass
//
class LabelCB(parentObj) of TextLabel(parentObj) custom
*- Name:	Client Border TextLabel

   with (this)
      height = 20
      width = 100
      metric = 6  // Pixels
      text = ""
      fontSize = 8
      borderStyle = 7   // Client
   endwith

endclass

class EntryBC(parentObj) of EntryField(parentObj) custom
*************
*- Entryfield, Base Class
*- 2001.0724
   with (this)
      height = 20
      width = 60
      metric = 6	// Pixels
      fontSize = 8
      colorHighLight = GotColor
   endwith

endclass

class EntryNA(parentObj) of EntryBC(parentObj) custom
*************
*- Entryfield, No Access
*- 2001.0724

	with (this)
	  	when = {||false}
      colorNormal = "BtnText/BtnFace"
      mousePointer = 1	//Arrow
   endwith
endclass
